library(ggpubr)
###################################################################

lf_unpaired_stats <- function(lf_data
                              , lf_stat_value = "param_value"
                              , lf_stat_group = "mutation_info_labels"
                              , lf_col_statvars = "param_type"
                              , my_paired = FALSE
                              , stat_adj = "none"){
  # ADDED NEW
  lf_data[[lf_stat_group]] = as.factor(lf_data[[lf_stat_group]])
  
  stat_formula = as.formula(paste0(lf_stat_value, "~", lf_stat_group))
  
  my_stat_df = compare_means(stat_formula
                             , group.by = lf_col_statvars
                             , data = lf_data
                             , paired = my_paired
                             , p.adjust.method =  stat_adj)  
  
  
  return(my_stat_df)
}
